#!/bin/bash
# Name: Steffen Wirth
# Homepage: http://www.pissflitsche.net/kernelscript
# Version: 0.3.7
# Datum: 22.05.2005
version=0.3.7
clear
if [ `id -un` != root ] 
	then 
		dialog --title "root access requirement" --backtitle "kernelscript $version" --msgbox "       Please start the script as root" 5 50
		exit 0
fi
rm -rf ~/.kernelscript/ 2> /dev/null
mkdir ~/.kernelscript/ 2> /dev/null
cd ~/.kernelscript/ && wget http://www.kernel.org/kdist/finger_banner 2> /dev/null
cat finger_banner | grep "The latest stable version of the Linux kernel is" | cut -b 61-66 >> stable26
cat finger_banner | grep "The latest stable version of the Linux kernel is" | cut -b 61-69 >> stable26test
cat finger_banner | grep "The latest 2.4 version of the Linux kernel is:" | cut -b 61-66 >> stable24
unset stable26
unset stable26test
unset stable24
stable26=`cat stable26`
stable26test=`cat stable26test`
stable24=`cat stable24`
clear
dialog --backtitle "kernelscript $version" --checklist "Please choose one kernel:" 0 0 0 "$stable26" "The latest 2.6 version" On "$stable26test" "The latest testing 2.6 version" Off "$stable24" "The latest 2.4 version" Off 2> ~/.kernelscript/vkernel
if [ $? == 0 ]; then

if [ `cat ~/.kernelscript/vkernel` == "\"$stable26\"" ] ; then
	mkdir /usr/src 2> /dev/null
	rm /usr/src/linux-$stable26.tar.gz & 2> /dev/null
	rm -rf /usr/src/linux-$stable26/ & 2> /dev/null
	cd /usr/src/ && wget ftp://ftp.kernel.org/pub/linux/kernel/v2.6/linux-$stable26.tar.gz || wget -c ftp://ftp.kernel.org/pub/linux/kernel/v2.6/linux-$stable26.tar.gz
	clear
	echo "Kernel becomes now unpacked!"
	tar -xvzf linux-$stable26.tar.gz && rm ./linux
	ln -s /usr/src/linux-$stable26 /usr/src/linux
	cd /usr/src/linux/ && make menuconfig
	make all && make modules_install || echo "compile error"
	cp ./System.map /boot/System.map-$stable26 &
	cp ./arch/i386/boot/bzImage /boot/vmlinuz-$stable26 &
	mkinitrd /boot/initrd-$stable26 $stable26 || mkinitrd || mk_initrd
	clear
	dialog --title "Kernel ready to boot" --backtitle "kernelscript $version" --msgbox "Kernel: /boot/vmlinuz-$stable26\nSystem: /boot/System.map-$stable26\nNow you must only insert the new kernel in your bootloader" 7 65
	exit 0
		else
		if [ `cat ~/.kernelscript/vkernel` == "\"$stable26test\"" ] ; then
				mkdir /usr/src 2> /dev/null
				rm /usr/src/linux-$stable26test.tar.gz & 2> /dev/null
				rm -rf /usr/src/linux-$stable26test/ & 2> /dev/null
				cd /usr/src/ && wget ftp://ftp.kernel.org/pub/linux/kernel/v2.6/linux-$stable26test.tar.gz || wget -c ftp://ftp.kernel.org/pub/linux/kernel/v2.6/linux-$stable26test.tar.gz
				clear
				echo "Kernel becomes now unpacked!"
				tar -xvzf linux-$stable26test.tar.gz && rm ./linux
				ln -s /usr/src/linux-$stable26test /usr/src/linux
				cd /usr/src/linux/ && make menuconfig
				make all && make modules_install || echo "compile error"
				cp ./System.map /boot/System.map-$stable26test &
				cp ./arch/i386/boot/bzImage /boot/vmlinuz-$stable26test &
				mkinitrd /boot/initrd-$stable26test $stable26test || mkinitrd || mk_initrd
				clear
				dialog --title "Kernel ready to boot" --backtitle "kernelscript $version" --msgbox "Kernel: /boot/vmlinuz-$stable26test\nSystem: /boot/System.map-$stable26test\nNow you must only insert the new kernel in your bootloader" 7 65
				exit 0
					else

						clear
						mkdir /usr/src 2> /dev/null
						rm /usr/src/linux-$stable24.tar.gz & 2> /dev/null
						rm -rf /usr/src/linux-$stable24/ & 2> /dev/null
						cd /usr/src/ && wget ftp://ftp.kernel.org/pub/linux/kernel/v2.4/linux-$stable24.tar.gz || wget -c ftp://ftp.kernel.org/pub/linux/kernel/v2.4/linux-$stable24.tar.gz
						clear
						echo "Kernel becomes now unpacked!"
						tar -xzf linux-$stable24.tar.gz && rm ./linux
						ln -s ./linux-$stable24 ./linux
						cd /usr/src/linux/ && make menuconfig
						make dep clean bzImage || echo "kernel compile error"
						make modules || echo "module compile error"
						make modules_install || echo "modules_install error"
						rm -rf /boot/System.map-$stable24 & 2> /dev/null
						rm -rf /boot/vmlinuz-$stable24 & 2> /dev/null
						cp ./System.map /boot/System.map-$stable24 &
						cp ./arch/i386/boot/bzImage /boot/vmlinuz-$stable24 &
						mkinitrd /boot/initrd-$stable24 $stable24 || mkinitrd || mk_initrd
						clear
						dialog --title "Kernel ready to boot" --backtitle "kernelscript $version" --msgbox "Kernel: /boot/vmlinuz-$stable24\nSystem: /boot/System.map-$stable24\nNow you must only insert the new kernel in your bootloader" 7 65
						exit
		fi
fi
else
	exit 0
fi
